cf Educational Codeforces Round 41 D. Pair Of Lines

2024-03-24 07:58

本文主要是介绍cf Educational Codeforces Round 41 D. Pair Of Lines,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

原题:
D. Pair Of Lines
time limit per test2 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
You are given n points on Cartesian plane. Every point is a lattice point (i. e. both of its coordinates are integers), and all points are distinct.

You may draw two straight lines (not necessarily distinct). Is it possible to do this in such a way that every point lies on at least one of these lines?

Input
The first line contains one integer n (1 ≤ n ≤ 105) — the number of points you are given.

Then n lines follow, each line containing two integers xi and yi (|xi|, |yi| ≤ 109)— coordinates of i-th point. All n points are distinct.

Output
If it is possible to draw two straight lines in such a way that each of given points belongs to at least one of these lines, print YES. Otherwise, print NO.

Examples
input
5
0 0
0 1
1 1
1 -1
2 2
output
YES
input
5
0 0
1 0
2 1
1 1
2 3
output
NO

Note
In the first example it is possible to draw two lines, the one containing the points 1, 3 and 5, and another one containing two remaining points.
这里写图片描述

中文:

给你一堆点,判断能否用两个直线把这些点都连接起来。

代码:

#include <iostream>
#include <cstring>
#include <algorithm>
#include <string>
#include <set>
#include <vector>
#include <cmath>
using namespace std;typedef long long ll;const int maxn = 100001;struct Point
{ll x,y;ll rx,ry;//根据原点对称后的点Point(ll x = 0, ll y = 0) :x(x), y(y){}
};typedef  Point Vector;bool line(const Point &p1, const Point &p2, const Point &p3)//判断三点是否共线
{return (p3.y - p1.y)*(p2.x - p1.x) - (p2.y - p1.y)*(p3.x - p1.x)==0;
}ll Cross(Vector A, Vector B)//叉积
{return A.rx*B.ry - A.ry*B.rx;
}bool cross_cmp(const Vector &a,const Vector &b)
{if(Cross(a,b)==0)//在一条直线上是等于0return a.rx<b.rx;elsereturn Cross(a,b)<0;
}int n;
vector<Point> v,one,two,three;bool solve(Point o,vector<Point> V)
{sort(V.begin(),V.end(),cross_cmp);vector<Point> tmp;int ind = 0,ans=0,pre=0;for (int i = 0; i < V.size();){int j = i + 1;while (j <V.size()){if (Cross(V[i], V[j])==0)j++;elsebreak;}if (j - i> ans +1 ){ans = j - i;//不算上原点pre = i;ind = j - 1;}i = j;}if(ans==0)return false;for (int i = 0; i < V.size(); i++){if (i<pre || i>ind)//去除在一个极角上的点tmp.push_back(V[i]);}if (tmp.size() <= 2)return true;for (int i = 2; i < tmp.size(); i++)//剩下的点是否在一条直线{if (!line(tmp[i-2], tmp[i-1], tmp[i]))return false;}return true;}
void trans(Point &p)//如果一个点在三,四象限或者在x轴负方向上,那么找到这个点关于原点的对称点
{if(p.ry<0||(p.ry==0&&p.rx<0)){p.rx=-p.rx;p.ry=-p.ry;}
}int main()
{ios::sync_with_stdio(false);Point tmp,a,b,c;while (cin >> n){v.clear();one.clear();two.clear();three.clear();for (int i = 0; i < n; i++){cin >> tmp.x >> tmp.y;v.push_back(tmp);}if (n <= 4){cout << "YES" << endl;continue;}a = v[0];b = v[1];c = v[2];for (int i = 0; i < v.size(); i++){if (i != 0)//以第一个点为原点{tmp.x = v[i].x - a.x;tmp.y = v[i].y - a.y;tmp.rx=tmp.x,tmp.ry=tmp.y;trans(tmp);one.push_back(tmp);}if (i != 1)//以第二个点为原点{tmp.x = v[i].x - b.x;tmp.y = v[i].y - b.y;tmp.rx=tmp.x,tmp.ry=tmp.y;trans(tmp);two.push_back(tmp);}if (i != 2)//以第三个点为原点{tmp.x = v[i].x - c.x;tmp.y = v[i].y - c.y;tmp.rx=tmp.x,tmp.ry=tmp.y;trans(tmp);three.push_back(tmp);}}if (solve(a, one) || solve(b, two) || solve(c, three)){cout << "YES" << endl;}else{cout << "NO" << endl;}}return 0;
}

解答:

此题思路倒是不难,代码有点麻烦,应该是我处理的不够好。

首先可以肯定的是,如果点少于4个,那么肯定能用两条直线串起来。

如果大于4个点,那么任取一个点作为原点,把所有点按照极角排序,角度相同的点,一定是在一条直线上的,找出角度相同最多的点,把这些点连上,作为第一条线。去掉第一条线上的点,判断剩下的点是否在一条线就完活。
如图
这里写图片描述

不过仅仅使用一个点作为原点来计算所有点的极角有这样一个问题,如果选取作为原点的点计算极角后,所有的角度都不一样,那是不是不能使用两个直线来连接?答案是否定的,因为会出现下面图中的情况。

这里写图片描述

红点表示在一条直线上的点,有两个,而且其中一个作为原点,黑点在另外一条直线上。可以看到,以其中任意一个红点作为原点,最后得到的极角都是不一样的,所以,起码要枚举三个点来作为原来判断。

在使用极角排序的过程中,使用的是叉积,使用叉积能够避免角度的问题,使用叉积来进行极角排序,只是判断以原点为起点,连接的两个点的向量,哪个在“左侧”,哪个在“右侧”,而且还有另外一个问题,那就是使用叉积得到的结果会有负值。

所以,这里将所有在三四象限以及在x轴负方向上的点画到原点对称的点上去,这样不会影响结果,因为如果一个点是和原点在一条直线上的点,那么关于原点对称的点也绝对在这个直线上,这样就可以枚举了。

这篇关于cf Educational Codeforces Round 41 D. Pair Of Lines的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/840944

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

cf 164 C 费用流

给你n个任务,k个机器,n个任务的起始时间,持续时间,完成任务的获利 每个机器可以完成任何一项任务,但是同一时刻只能完成一项任务,一旦某台机器在完成某项任务时,直到任务结束,这台机器都不能去做其他任务 最后问你当获利最大时,应该安排那些机器工作,即输出方案 具体建图方法: 新建源汇S T‘ 对任务按照起始时间s按升序排序 拆点: u 向 u'连一条边 容量为 1 费用为 -c,

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

CF 508C

点击打开链接 import java.util.Arrays;import java.util.Scanner;public class Main {public static void main(String [] args){new Solve().run() ;} }class Solve{int bit[] = new int[608] ;int l

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

【CF】C. Glass Carving(二分 + 树状数组 + 优先队列 + 数组计数)

这题简直蛋疼死。。。。。 A了一下午 #include<cstdio>#include<queue>#include<cstring>#include<algorithm>using namespace std;typedef long long LL;const int maxn = 200005;int h,w,n;int C1[maxn],C2[maxn];int

【CF】E. Anya and Cubes(双向DFS)

根据题意的话每次递归分3种情况 一共最多25个数,时间复杂度为3^25,太大了 我们可以分2次求解第一次求一半的结果,也就是25/2 = 12,记录结果 之后利用剩余的一半求结果 s-结果 = 之前记录过的结果 就可以 时间复杂度降低为 3 ^ (n/2+1) 题目链接:http://codeforces.com/contest/525/problem/E #include<set